local BagBox, BankBox

local Match, Med, Box
function ContainerFrame_UpdateSearchResults(frame)
	local id = frame:GetID();
	local name = frame:GetName().."Item";
	local itemButton, Box,kind,iD,Found
	local _, isFiltered;
	Match={}
	Med={}

	Box=strlower(BagItemSearchBox:GetText())
	for word in Box:gmatch("%S+") do table.insert(Match,strlower(word)) end
	for i=1, frame.size, 1 do
		Med={}
		stats=false
		itemButton = _G[name..i] or frame["Item"..i];
		iD = itemButton:GetID()
		stats=BSP_Search(Match,id,iD)
		_, _, _, _, _, _, _, isFiltered = GetContainerItemInfo(id, iD);
		if ( isFiltered ) then
			if not(stats) then
				itemButton.searchOverlay:Show();
			else
			itemButton.searchOverlay:Hide();
			end
		else
			itemButton.searchOverlay:Hide();
		end
	end
end

function BSP_Search(Match,id,iD)
	Med={}
		if GetContainerItemLink(id, iD) then
			for k,v in pairs(GetItemStats(GetContainerItemLink(id, iD))) do
				table.insert(Med,strlower(k))
			end
			local namn,_,_,Ilvl,_,_,kind,_,place=GetItemInfo(GetContainerItemLink(id, iD))
			if kind then table.insert(Med,strlower(kind)) end
			if Ilvl then table.insert(Med,Ilvl) end
			if not(place=="") then table.insert(Med,strlower(place)) end
			Found=0
			for i=1, #Match do
				for q=1,#Med do
					if string.find(Med[q],Match[i]) then
						Found=Found+1
						break
					end
				end
			end
			if Found==#Match then return true else return false end
		end
	end
-----------------------------For ElvUI users-----------------





local eventframe = CreateFrame("FRAME", "BspEventframe");

eventframe:RegisterEvent("ADDON_LOADED")





local E,L,V,P,G,B
local function Inject()
	if IsAddOnLoaded("ElvUI") then
		E, L, V, P, G = unpack(ElvUI); --Inport: Engine, Locales, PrivateDB, ProfileDB, GlobalDB
		B = E:GetModule('Bags');
		eventframe:UnregisterEvent("ADDON_LOADED")
		B.SetSearch = MyINVENTORY_SEARCH_UPDATE
	end
end

local function eventHandler(self,event,...)
	if event=="ADDON_LOADED" and ...=="Bagsearchplus" then
		Inject()
	elseif event=="ADDON_LOADED" and ...=="ElvUI" then
		Inject()
	end
end
eventframe:SetScript("OnEvent", eventHandler);
function MyINVENTORY_SEARCH_UPDATE()
	Match={}
	local BagBox=strlower(ElvUI_ContainerFrameEditBox:GetText())
	if ElvUI_BankContainerFrameEditBox then
	print("I SHOULD DO THIS")
		BankBox=strlower(ElvUI_BankContainerFrameEditBox:GetText())
	end
	if not(BagBox=="search") then
		Box=BagBox
	elseif not(BankBox=="search") then
		Box=BankBox
	else
		Box=""
	end
	--Box=strlower(ElvUI_ContainerFrameEditBox:GetText()) or strlower(ElvUI_BankContainerFrameEditBox:GetText())
	--if Box~="search" then
	--	SetItemSearch(Box)
	--else
	if Box then
		SetItemSearch(Box)
	else
		SetItemSearch("")
	end
	print(Box)
	if Box then
		for word in Box:gmatch("%S+") do table.insert(Match,strlower(word)) end
	end
	for _, bagFrame in pairs(B.BagFrames) do

		for _, bagID in ipairs(bagFrame.BagIDs) do
			for slotID = 1, GetContainerNumSlots(bagID) do
				Med={}
				stats=false
				local _, _, _, _, _, _, _, isFiltered = GetContainerItemInfo(bagID, slotID);
				local button = bagFrame.Bags[bagID][slotID];

				local stats=BSP_Search(Match, bagID, slotID)
				if ( isFiltered ) then
					if stats==true then
						SetItemButtonDesaturated(button);
						button:SetAlpha(1)
					else
						SetItemButtonDesaturated(button, 1);
						button:SetAlpha(0.4);
					end
				else
					SetItemButtonDesaturated(button);
					button:SetAlpha(1);
				end
			end
		end
	end

	if(ElvUIReagentBankFrameItem1) then
		for slotID=1, 98 do
			Med={}
			stats=false
			local _, _, _, _, _, _, _, isFiltered = GetContainerItemInfo(REAGENTBANK_CONTAINER, slotID);
			local button = _G["ElvUIReagentBankFrameItem"..slotID]
			if word then
				local stats=BSP_Search(word,REAGENTBANK_CONTAINER,slotID)
			end
			if ( isFiltered ) then
				if stats==true then
					SetItemButtonDesaturated(button);
					button:SetAlpha(1)
				else
					SetItemButtonDesaturated(button, 1);
					button:SetAlpha(0.4);
				end
			else
				SetItemButtonDesaturated(button);
				button:SetAlpha(1);
			end
		end
	end
end

